#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_item.h"
std::auto_ptr<M_item> M_item::msSingleton(nullptr);

int M_item::GetCount()
{
	return (int)mMapData.size();
}

const M_itemData* M_item::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_itemData>& M_item::GetMapData()
{
	return mMapData;
}

void M_item::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_item.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_itemData data;
		data.mID = element->IntAttribute("ID");
		data.mname = element->Attribute("name");
		data.mdesc = element->Attribute("desc");
		data.mtype = element->IntAttribute("type");
		data.mquality = element->IntAttribute("quality");
		data.micon = element->Attribute("icon");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_item Loaded. Load Data:%u", mMapData.size());
}

void M_item::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_item");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_item");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_itemData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "name", data.mname);
		LuaCfgHelper::readString(L, "desc", data.mdesc);
		LuaCfgHelper::readInt(L, "type", data.mtype);
		LuaCfgHelper::readInt(L, "quality", data.mquality);
		LuaCfgHelper::readString(L, "icon", data.micon);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_item Loaded. Load Data:%u", mMapData.size());
}

void M_item::Reload()
{
	mMapData.clear();
	Load();
}

M_item* M_item::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_item());
	}
	return msSingleton.get();
}

void M_item::Release()
{
	msSingleton.reset(nullptr);
}
